﻿-- Daily Tamer Check
-- by Fluffies
-- EU-Well of Eternity
local ldb = LibStub:GetLibrary("LibDataBroker-1.1")

local dtcicon = "Interface\\ICONS\\INV_MISC_PETMOONKINTA"

-- string colors
local LIGHT_RED   = "|cffFF2020"
local LIGHT_GREEN = "|cff20FF20"
local LIGHT_BLUE  = "|cff00ddFF"
local ZONE_BLUE   = "|cff00aacc"
local GREY        = "|cff999999"
local COORD_GREY  = "|cffBBBBBB"
local GOLD        = "|cffffcc00"
local WHITE       = "|cffffffff"
local function AddColor(str,color)
 return color..str.."|r"
end

local EKK   = 0; -- eastern kingdoms, kalimdor frame
local ONC   = 1; -- outlands, northrend, cataclysm frame
local ABOUT = 2; -- about frame
local COORDS_CHECK = 3; -- "activate/deactivate coordinates" button

local mainframe,btnclose, -- dtc frame and its close button
      satchels_table, -- mainframe table
      WEheader,WEtable  -- world events table
local frame = {}  -- minor tamers frames
local btn = {} -- minor tamers buttons
local tables = {} -- minor tamers tables
------- constants ------------------------------
local npcnamecolor = GREY
local zonecolor = ZONE_BLUE
local coordcolor = COORD_GREY
local mainframenpcnamecolor = GREY
local mainframezonecolor = GREY
local mainframecoordcolor = COORD_GREY

-- buttons' textures
local tx_btnnorth     = "Interface\\icons\\Achievement_Zone_Northrend_01"
local tx_btnkalim     = "Interface\\icons\\Achievement_Zone_Kalimdor_01"
local tx_btnabout     = "Interface\\icons\\Icon_PetFamily_Beast"
local tx_chkcoords    = "Interface\\icons\\INV_Misc_Map_01"
local opt_framespeed = 20  -- frames animation speed
--local worldeventschecked = false

 local coordinates = {     [32434] = " (57,42)",[32439] = " (61,88)",[32441] = " (65,94)",[32440] = " (29,36)",
            [31957] = " (55,38)",[31991] = " (36,52)",[31956] = " (36,74)",[31955] = " (46,44)",
            [31954] = " (62,45)",[31953] = " (48,54)",[31958] = " (68,41)",[31935] = " (77,20)",
            [31926] = " (31,42)",[31916] = " (40,77)",[31909] = " (66,65)",[31971] = " (57,42)",
            [31923] = " (17,50)",[31925] = " (59,70)",[31924] = " (61,49)",[31922] = " (64,49)",
            [31931] = " (29,34)",[31934] = " (13,67)",[31932] = " (50,59)",[31933] = " (59,77)",
            [31973] = " (50,57)",[31972] = " (61,33)",[31974] = " (57,57)",[31854] = " (20,29)",
            [31904] = " (39,79)",[31819] = " (58,53)",[31908] = " (46,60)",[31905] = " (53,74)",
            [31906] = " (32,33)",[31872] = " (57,45)",[31871] = " (60,50)",[31907] = " (40,56)",
            [31862] = " (59,71)",[31818] = " (44,28)",[31851] = " (51,73)",[31910] = " (62,54)",
            [31911] = " (67,54)",[31914] = " (25,47)",[31850] = " (20,44)",[31913] = " (76,41)",
            [31693] = " (42,84)",[31912] = " (35,27)",[31781] = " (33,52)",[31780] = " (61,19)",
            [31852] = " (46,40)" }
 local blank = {     [32434] = "",[32439] = "",[32441] = "",[32440] = "",
            [31957] = "",[31991] = "",[31956] = "",[31955] = "",
            [31954] = "",[31953] = "",[31958] = "",[31935] = "",
            [31926] = "",[31916] = "",[31909] = "",[31971] = "",
            [31923] = "",[31925] = "",[31924] = "",[31922] = "",
            [31931] = "",[31934] = "",[31932] = "",[31933] = "",
            [31973] = "",[31972] = "",[31974] = "",[31854] = "",
            [31904] = "",[31819] = "",[31908] = "",[31905] = "",
            [31906] = "",[31872] = "",[31871] = "",[31907] = "",
            [31862] = "",[31818] = "",[31851] = "",[31910] = "",
            [31911] = "",[31914] = "",[31850] = "",[31913] = "",
            [31693] = "",[31912] = "",[31781] = "",[31780] = "",
            [31852] = "" }

local function GenerateDTCTables()
 local c
 if DailyTamerCheck_Options["show_coordinates"] then c = coordinates else c = blank end

       WEheader = EVENTS_LABEL
       WEtable = {}
       WEtable[CALENDAR_FILTER_DARKMOON] = { questID = 32175, name = "|TInterface\\icons\\INV_Misc_Eye_01:12|t "..CALENDAR_FILTER_DARKMOON.." (Jeremy Feasel)" }
       -- future world event tamers here
       satchels_table = { [select(2,GetAchievementInfo(7936))] = {
                  [32434] = "|TInterface\\icons\\INV_Pet_PandarenElemental_Fire:12|t "..AddColor(GetAchievementCriteriaInfo(6974,5),mainframezonecolor)..AddColor(c[32434],mainframecoordcolor), -- townlong steppes
                  [32439] = "|TInterface\\icons\\Inv_pet_PandarenElemental:12|t "..AddColor(GetAchievementCriteriaInfo(6974,6),mainframezonecolor)..AddColor(c[32439],mainframecoordcolor), -- dread wastes
                  [32441] = "|TInterface\\icons\\INV_Pet_PandarenElemental_Earth:12|t "..AddColor(GetAchievementCriteriaInfo(6974,4),mainframezonecolor)..AddColor(c[32441],mainframecoordcolor), -- kun-lai
                  [32440] = "|TInterface\\icons\\INV_Pet_PandarenElemental_Air:12|t "..AddColor(GetAchievementCriteriaInfo(6974,1),mainframezonecolor)..AddColor(c[32440],mainframecoordcolor)}, -- jade forest
               [select(2,GetAchievementInfo(6606))] = {
                  [31957] = AddColor(GetAchievementCriteriaInfo(6974,6),mainframezonecolor)..AddColor(c[31957],mainframecoordcolor)..AddColor(" (Shu)",mainframenpcnamecolor),--dread wastes
                  [31991] = AddColor(GetAchievementCriteriaInfo(6974,5),mainframezonecolor)..AddColor(c[31991],mainframecoordcolor)..AddColor(" (Zusshi)",mainframenpcnamecolor), -- townlong
                  [31956] = AddColor(GetAchievementCriteriaInfo(6974,4),mainframezonecolor)..AddColor(c[31956],mainframecoordcolor)..AddColor(" (Yon)",mainframenpcnamecolor), -- kun-lai
                  [31955] = AddColor(GetAchievementCriteriaInfo(6974,2),mainframezonecolor)..AddColor(c[31955],mainframecoordcolor)..AddColor(" (Nishi)",mainframenpcnamecolor), -- valley
                  [31954] = AddColor(GetAchievementCriteriaInfo(6974,3),mainframezonecolor)..AddColor(c[31954],mainframecoordcolor)..AddColor(" (Mo'ruk)",mainframenpcnamecolor), -- krasarang
                  [31953] = AddColor(GetAchievementCriteriaInfo(6974,1),mainframezonecolor)..AddColor(c[31953],mainframecoordcolor)..AddColor(" (Hyuna)",mainframenpcnamecolor), -- jade forest
                  [31958] = AddColor(GetAchievementCriteriaInfo(6974,7),mainframezonecolor)..AddColor(c[31958],mainframecoordcolor)..AddColor(" (Aki)",mainframenpcnamecolor)}, -- vale
               [select(2,GetAchievementInfo(6607))] = {
                  [31935] = AddColor(GetAchievementCriteriaInfo(45,9),mainframezonecolor)..AddColor(c[31935],mainframecoordcolor)..AddColor(" (Payne)",mainframenpcnamecolor), --icecrown
                  [31926] = AddColor(GetAchievementCriteriaInfo(44,7),mainframezonecolor)..AddColor(c[31926],mainframecoordcolor)..AddColor(" (Antari)",mainframenpcnamecolor), --shadowmoon
                  [31916] = AddColor(GetAchievementCriteriaInfo(42,22),mainframezonecolor)..AddColor(c[31916],mainframecoordcolor)..AddColor(" (Lydia)",mainframenpcnamecolor), -- deadwind pass
                  [31909] = AddColor(GetAchievementCriteriaInfo(43,6),mainframezonecolor)..AddColor(c[31909],mainframecoordcolor)..AddColor(" (Trixxy)",mainframenpcnamecolor), -- winterspring
                  [31971] = AddColor(GetAchievementCriteriaInfo(4868,4),mainframezonecolor)..AddColor(c[31971],mainframecoordcolor)..AddColor(" (Obalis)",mainframenpcnamecolor)} } -- uldum

 tables[ONC] = { [select(2,GetAchievementInfo(6604))] = { -- outlands
                  [31923] = AddColor(GetAchievementCriteriaInfo(44,2),zonecolor)..AddColor(c[31923],coordcolor)..AddColor(" ("..GetAchievementCriteriaInfo(6604,2)..")",npcnamecolor), -- zangarmarsh
                  [31925] = AddColor(GetAchievementCriteriaInfo(867,8),zonecolor)..AddColor(c[31925],coordcolor)..AddColor(" ("..GetAchievementCriteriaInfo(6604,4)..")",npcnamecolor), -- shattrath
                  [31924] = AddColor(GetAchievementCriteriaInfo(44,4),zonecolor)..AddColor(c[31924],coordcolor)..AddColor(" ("..GetAchievementCriteriaInfo(6604,3)..")",npcnamecolor), --nagrand
                  [31922] = AddColor(GetAchievementCriteriaInfo(44,1),zonecolor)..AddColor(c[31922],coordcolor)..AddColor(" ("..GetAchievementCriteriaInfo(6604,1)..")",npcnamecolor)},--hellfire
               [select(2,GetAchievementInfo(6605))] = {
                  [31931] = AddColor(GetAchievementCriteriaInfo(45,2),zonecolor)..AddColor(c[31931],coordcolor)..AddColor(" ("..GetAchievementCriteriaInfo(6605,1)..")",npcnamecolor), --howling fjord
                  [31934] = AddColor(GetAchievementCriteriaInfo(45,5),zonecolor)..AddColor(c[31934],coordcolor)..AddColor(" ("..GetAchievementCriteriaInfo(6605,4)..")",npcnamecolor), --zul drak
                  [31932] = AddColor(GetAchievementCriteriaInfo(45,7),zonecolor)..AddColor(c[31932],coordcolor)..AddColor(" ("..GetAchievementCriteriaInfo(6605,2)..")",npcnamecolor), --crystalsong
                  [31933] = AddColor(GetAchievementCriteriaInfo(45,3),zonecolor)..AddColor(c[31933],coordcolor)..AddColor(" ("..GetAchievementCriteriaInfo(6605,3)..")",npcnamecolor)}, --dragonblight
               [select(2,GetAchievementInfo(7525))] = {
                  [31973] = AddColor(GetAchievementCriteriaInfo(4868,3),zonecolor)..AddColor(c[31973],coordcolor)..AddColor(" ("..GetAchievementCriteriaInfo(7525,2)..")",npcnamecolor), --deepholm
                  [31972] = AddColor(GetAchievementCriteriaInfo(4868,1),zonecolor)..AddColor(c[31972],coordcolor)..AddColor(" ("..GetAchievementCriteriaInfo(7525,1)..")",npcnamecolor), --mount hyjal
                  [31974] = AddColor(GetAchievementCriteriaInfo(4868,5),zonecolor)..AddColor(c[31974],coordcolor)..AddColor(" ("..GetAchievementCriteriaInfo(7525,3)..")",npcnamecolor)} } --twilight highlands

tables[EKK] = { [select(2,GetAchievementInfo(6602)).." ("..FACTION_HORDE..")"] = { -- horde only (kalimdor)
                  [31854] = AddColor(GetAchievementCriteriaInfo(43,10),zonecolor)..AddColor(c[31854],coordcolor)..AddColor(" ("..GetAchievementCriteriaInfo(6602,3)..")",npcnamecolor), --ashenvale
                  [31904] = AddColor(GetAchievementCriteriaInfo(43,7),zonecolor)..AddColor(c[31904],coordcolor)..AddColor(" ("..GetAchievementCriteriaInfo(6602,8)..")",npcnamecolor), --southern barrens
                  [31819] = AddColor(GetAchievementCriteriaInfo(43,5),zonecolor)..AddColor(c[31819],coordcolor)..AddColor(" ("..GetAchievementCriteriaInfo(6602,2)..")",npcnamecolor),--northrend barrens
                  [31908] = AddColor(GetAchievementCriteriaInfo(43,20),zonecolor)..AddColor(c[31908],coordcolor)..AddColor(" ("..GetAchievementCriteriaInfo(6602,7)..")",npcnamecolor), --moonglade
                  [31905] = AddColor(GetAchievementCriteriaInfo(43,14),zonecolor)..AddColor(c[31905],coordcolor)..AddColor(" ("..GetAchievementCriteriaInfo(6602,9)..")",npcnamecolor), --dustwallow marsh
                  [31906] = AddColor(GetAchievementCriteriaInfo(43,11),zonecolor)..AddColor(c[31906],coordcolor)..AddColor(" ("..GetAchievementCriteriaInfo(6602,11)..")",npcnamecolor),--thousand needles
                  [31872] = AddColor(GetAchievementCriteriaInfo(43,13),zonecolor)..AddColor(c[31872],coordcolor)..AddColor(" ("..GetAchievementCriteriaInfo(6602,5)..")",npcnamecolor), --desolace
                  [31871] = AddColor(GetAchievementCriteriaInfo(43,15),zonecolor)..AddColor(c[31871],coordcolor)..AddColor(" ("..GetAchievementCriteriaInfo(6602,6)..")",npcnamecolor),--feralas
                  [31907] = AddColor(GetAchievementCriteriaInfo(43,18),zonecolor)..AddColor(c[31907],coordcolor)..AddColor(" ("..GetAchievementCriteriaInfo(6602,10)..")",npcnamecolor),--felwood
                  [31862] = AddColor(GetAchievementCriteriaInfo(43,12),zonecolor)..AddColor(c[31862],coordcolor)..AddColor(" ("..GetAchievementCriteriaInfo(6602,4)..")",npcnamecolor), --stonetalon
                  [31818] = AddColor(GetAchievementCriteriaInfo(43,1),zonecolor)..AddColor(c[31818],coordcolor)..AddColor(" ("..GetAchievementCriteriaInfo(6602,1)..")",npcnamecolor)},--durotar
                        [select(2,GetAchievementInfo(6603)).." ("..FACTION_ALLIANCE..")"] = { -- alliance only (eastern kingdoms)
                  [31851] = AddColor(GetAchievementCriteriaInfo(42,17),zonecolor)..AddColor(c[31851],coordcolor)..AddColor(" ("..GetAchievementCriteriaInfo(6603,6)..")",npcnamecolor), --cape of stranglethorn
                  [31910] = AddColor(GetAchievementCriteriaInfo(42,19),zonecolor)..AddColor(c[31910],coordcolor)..AddColor(" ("..GetAchievementCriteriaInfo(6603,7)..")",npcnamecolor), --hinterlands
                  [31911] = AddColor(GetAchievementCriteriaInfo(42,24),zonecolor)..AddColor(c[31911],coordcolor)..AddColor(" ("..GetAchievementCriteriaInfo(6603,8)..")",npcnamecolor),--eastern plaguelands
                  [31914] = AddColor(GetAchievementCriteriaInfo(42,5),zonecolor)..AddColor(c[31914],coordcolor)..AddColor(" ("..GetAchievementCriteriaInfo(6603,10)..")",npcnamecolor), --burning steppes
                  [31850] = AddColor(GetAchievementCriteriaInfo(42,7),zonecolor)..AddColor(c[31850],coordcolor)..AddColor(" ("..GetAchievementCriteriaInfo(6603,4)..")",npcnamecolor), --duskwood
                  [31913] = AddColor(GetAchievementCriteriaInfo(42,18),zonecolor)..AddColor(c[31913],coordcolor)..AddColor(" ("..GetAchievementCriteriaInfo(6603,11)..")",npcnamecolor),--swamp of sorrows
                  [31693] = AddColor(GetAchievementCriteriaInfo(42,1),zonecolor)..AddColor(c[31693],coordcolor)..AddColor(" ("..GetAchievementCriteriaInfo(6603,1)..")",npcnamecolor), --elwynn forest
                  [31912] = AddColor(GetAchievementCriteriaInfo(42,13),zonecolor)..AddColor(c[31912],coordcolor)..AddColor(" ("..GetAchievementCriteriaInfo(6603,9)..")",npcnamecolor),--searing gorge
                  [31781] = AddColor(GetAchievementCriteriaInfo(42,10),zonecolor)..AddColor(c[31781],coordcolor)..AddColor(" ("..GetAchievementCriteriaInfo(6603,3)..")",npcnamecolor),--redridge mountains
                  [31780] = AddColor(GetAchievementCriteriaInfo(42,20),zonecolor)..AddColor(c[31780],coordcolor)..AddColor(" ("..GetAchievementCriteriaInfo(6603,2)..")",npcnamecolor), --westfall
                  [31852] = AddColor(GetAchievementCriteriaInfo(42,16),zonecolor)..AddColor(c[31852],coordcolor)..AddColor(" ("..GetAchievementCriteriaInfo(6603,5)..")",npcnamecolor)} }--northern stranglethorn
end

-- check for active world events
local function AddWorldEventTamers()
 local i
 local _,_,today = CalendarGetDate()
 for i = 1,CalendarGetNumDayEvents(0,today) do
  local title = CalendarGetDayEvent(0, today, i)
  table.foreach(WEtable,function(k,v)
   if title == k then
    if not satchels_table[WEheader] then satchels_table[WEheader] = {} end
    satchels_table[WEheader][v.questID] = v.name
   end
  end)
 end
 --worldeventschecked = true
end

local function DrawTCheckMainframe(obj, tab, istooltip)

 --if not worldeventschecked then
 AddWorldEventTamers()
 --end

 obj:ClearLines()
 obj:AddDoubleLine("Daily Tamer Check","|T"..dtcicon..":32|t")

  table.foreach(tab,function(k,v)
  --min width
   obj:AddLine("                                                      ")
   obj:AddLine(k)
   table.foreach(v,
    function(questID,questName)
    if IsQuestFlaggedCompleted(questID) then 
     obj:AddDoubleLine(AddColor(questName,GREY),AddColor(COMPLETE,LIGHT_GREEN))
    else
     obj:AddDoubleLine(AddColor(questName,GREY),AddColor(INCOMPLETE,LIGHT_RED))
    end
   end)
  end)
  if not istooltip then
   mainframe:AddLine(" ")
   mainframe:AddLine(" ")
   mainframe:AddLine(" ")
  end
end

local function DrawTCheckFrame(obj, tab)
 local tmpleft  = ""
 local tmpright = ""

 local function adddoubleline(s1,s2,col1,col2)
  tmpleft  = tmpleft.."\n"..AddColor(s1,col1)
  tmpright = tmpright.."\n"..AddColor(s2,col2)
  
  local s1tmp
  s1tmp = string.gsub(s1,"|c........","")
  s1tmp = string.gsub(s1tmp,"|r","")
  obj.leftfont:SetText(s1tmp..s2)
  local tmplen = obj.leftfont:GetStringWidth(obj.leftfont)+40
  --if ((tmplen * strlen(s1tmp..s2)) > obj.maxwidth) then
   --obj.maxwidth = tmplen * strlen(s1tmp..s2)
  if (tmplen > obj.maxwidth) then
   obj.maxwidth = tmplen
  end
 end

  table.foreach(tab,function(k,v)
   adddoubleline("","",GREY,GREY)
   adddoubleline(k,"",GOLD,GREY)
   table.foreach(v,
    function(questID,questName)
    if IsQuestFlaggedCompleted(questID) then 
     adddoubleline(questName,COMPLETE,GREY,LIGHT_GREEN)
    else
     adddoubleline(questName,INCOMPLETE,GREY,LIGHT_RED)
    end
   end)
  end)

 obj.leftfont:SetText(tmpleft)
 obj.rightfont:SetText(tmpright)
end

local function CheckFramesAnimation(id)
 if (frame[id]) and (frame[id]:IsVisible()) and (frame[id].maxwidth ~= nil) and (frame[id].width ~= nil) and (frame[id].opening ~= nil) then
  if frame[id].opening then
   if frame[id].width < frame[id].maxwidth then
    frame[id].width = frame[id].width + opt_framespeed
    if id == ABOUT then
     frame[id]:SetHeight(frame[id].width)
    else
     frame[id]:SetWidth(frame[id].width)
    end
   elseif (not frame[id].leftfont:IsVisible()) then
    frame[id].leftfont:Show()
    frame[id].rightfont:Show()
   end
  else
   if frame[id].width > opt_framespeed then
    frame[id].width = frame[id].width - opt_framespeed
    if id == ABOUT then
     frame[id]:SetHeight(frame[id].width)
    else
     frame[id]:SetWidth(frame[id].width)
    end
    if (frame[id].leftfont:IsVisible()) then
     frame[id].leftfont:Hide()
     frame[id].rightfont:Hide()
    end
   else
    frame[id]:Hide()
   end
  end
 end
end

local function CreateNewFrameButton(id,pos,tx)
  if not btn[id] then
   btn[id] = CreateFrame("FRAME", nil, mainframe)
   btn[id].texture = btn[id]:CreateTexture()
  end
  if pos == "left" then
   btn[id]:SetPoint("BOTTOMLEFT", mainframe, "BOTTOMLEFT",10,10)
  elseif pos == "right" then
   btn[id]:SetPoint("BOTTOMRIGHT", mainframe, "BOTTOMRIGHT",-10,10)
  elseif pos == "bottom" then
   btn[id]:SetPoint("BOTTOMRIGHT", mainframe, "BOTTOMRIGHT",-45,10)
  end
  btn[id]:SetWidth(25)
  btn[id]:SetHeight(25)
  btn[id].texture:SetAllPoints()
  btn[id].texture:SetTexture(tx)
  
  btn[id]:SetScript("OnEnter", function(self)
   if not frame[id] then
    frame[id] = CreateFrame("Frame")
    
    frame[id].texture = frame[id]:CreateTexture()
    frame[id].texture:SetAllPoints()
    frame[id].texture:SetTexture(0,0,0,0.7)
    
    frame[id].leftfont = frame[id]:CreateFontString(nil, "OVERLAY", "GameTooltipText")
    frame[id].leftfont:SetParent(frame[id])
    frame[id].leftfont:SetPoint("TOPLEFT",10,-10)

    frame[id].rightfont = frame[id]:CreateFontString(nil, "OVERLAY", "GameTooltipText")
    frame[id].rightfont:SetParent(frame[id])
    frame[id].rightfont:SetPoint("TOPRIGHT",-10,-10)
    
    frame[id].width = 1
   end
    if id == ABOUT then
     frame[id].leftfont:SetText(AddColor(" Daily Tamer Check ",GOLD).."\n"..
                                         AddColor(" by\n",GREY)..
                                         AddColor(" Fluffies",LIGHT_BLUE)..
                                         AddColor(" EU-Well of Eternity",GREY))
     frame[id].rightfont:SetText("|T"..dtcicon..":24|t\n")
     frame[id].maxwidth = 60
    else
     frame[id].maxwidth = 200
    end
   
   frame[id].leftfont:Hide()
   frame[id].rightfont:Hide()

   frame[id]:SetFrameStrata("DIALOG")
   frame[id]:SetToplevel(true)
   frame[id]:SetScale(0.9)
   frame[id]:SetClampedToScreen(true)
   frame[id]:ClearAllPoints()
   if pos == "left" then
    frame[id]:SetPoint("TOPRIGHT", mainframe, "TOPLEFT")
    frame[id]:SetPoint("BOTTOMRIGHT", mainframe, "BOTTOMLEFT")
   elseif pos == "right" then
    frame[id]:SetPoint("TOPLEFT", mainframe, "TOPRIGHT")
    frame[id]:SetPoint("BOTTOMLEFT", mainframe, "BOTTOMRIGHT")
   elseif pos == "bottom" then
    frame[id]:SetPoint("TOPLEFT", mainframe, "BOTTOMLEFT")
    frame[id]:SetPoint("TOPRIGHT", mainframe, "BOTTOMRIGHT")
   end
   frame[id].opening = true
   frame[id]:SetWidth(frame[id].width)
   if id == EKK or id == ONC then
    DrawTCheckFrame(frame[id],tables[id])
   end

   frame[id]:Show()
  end)

  btn[id]:SetScript("OnLeave", function(self)
   if frame[id] then 
    frame[id].opening = false 
   end
  end)

  btn[id]:Show()
end --CreateNewFrameButton

local function CreateCheckBox(id,tx,tx_on,tx_off)

 local function setcheckboxtexture(flag)
  local shaderSupported = btn[id].texture:SetDesaturated(not flag);
  if not shaderSupported then
   if not flag then
     btn[id].texture:SetVertexColor(0.5, 0.5, 0.5);
   else
     btn[id].texture:SetVertexColor(1.0, 1.0, 1.0);
   end
  end
 end

  if not btn[id] then
   btn[id] = CreateFrame("FRAME", nil, mainframe)
   btn[id].texture = btn[id]:CreateTexture()
  end
  -- hardcoded position since I need only 1 checkbox atm
  btn[id]:SetPoint("BOTTOMLEFT", mainframe, "BOTTOMLEFT",45,10)
  btn[id]:SetWidth(25)
  btn[id]:SetHeight(25)
  btn[id].texture:SetAllPoints()
  btn[id].texture:SetTexture(tx)
  setcheckboxtexture(DailyTamerCheck_Options["show_coordinates"])


  btn[id]:SetScript("OnMouseUp", function(self)
   DailyTamerCheck_Options["show_coordinates"] = not DailyTamerCheck_Options["show_coordinates"]
   GenerateDTCTables()
   DrawTCheckMainframe(mainframe,satchels_table,false)
   setcheckboxtexture(DailyTamerCheck_Options["show_coordinates"])
   mainframe:Show()
   collectgarbage()
  end)
  
  btn[id]:SetScript("OnEnter", function(self)
   GameTooltip:SetOwner(btn[id],"ANCHOR_BOTTOM")
   GameTooltip:ClearLines()
   GameTooltip:AddLine("Toggle map coordinates")

   GameTooltip:Show()
  end)

  btn[id]:SetScript("OnLeave", function(self)
   GameTooltip:Hide()
  end)

  btn[id]:Show()
end --CreateCheckBox


local function tamerquestcheck()

 if not mainframe then
  mainframe = CreateFrame("GameTooltip", "dtcmainframe", nil, "GameTooltipTemplate")
 end
 mainframe:SetOwner(UIParent,"ANCHOR_NONE")
 mainframe:SetPoint("CENTER",UIParent,"CENTER")
 mainframe:SetFrameStrata("HIGH")
 mainframe:EnableMouse(true)
 mainframe:SetToplevel(true)
 mainframe:SetMovable()
 mainframe:SetPadding(16)
 mainframe:SetScale(0.9)
 mainframe:RegisterForDrag("LeftButton")
 mainframe:SetScript("OnDragStart", function(self) 
		self:StartMoving()
 end)
 mainframe:SetScript("OnDragStop", function(self) 
		self:StopMovingOrSizing()
 end)
 -- frames closing animation
  mainframe:SetScript("OnUpdate", function(self)
   if frame[ONC] then
    CheckFramesAnimation(ONC)
   end
   if frame[EKK] then
    CheckFramesAnimation(EKK)
   end
   if frame[ABOUT] then
    CheckFramesAnimation(ABOUT)
   end
  end)
 DrawTCheckMainframe(mainframe,satchels_table,false)

 if not btnclose then
  btnclose = CreateFrame("Button", "dtcclosebtn", mainframe, "UIPanelButtonTemplate")
 end
 btnclose:SetPoint("BOTTOM", mainframe, "BOTTOM",0,10)
 btnclose:SetWidth(140)
 btnclose:SetText(CLOSE)
 btnclose:SetScript("OnClick", function(self)
  mainframe:Hide()
  if frame then
   table.foreach(frame,function(k,v) frame[k]:Hide() end)
  end
  collectgarbage()
 end)

 btnclose:Show()
 
 CreateNewFrameButton(EKK,"left",tx_btnkalim)
 CreateNewFrameButton(ONC,"right",tx_btnnorth)
 CreateNewFrameButton(ABOUT,"bottom",tx_btnabout)
 CreateCheckBox(COORDS_CHECK,tx_chkcoords,tx_chkcoordson,tx_chkcoordsoff)

 mainframe:Show()
end

local DailyTamerCheck = ldb:NewDataObject("DailyTamerCheck", {
	type = "data source",
	icon = dtcicon,
	label = "Daily Tamer Check",
	OnClick = function(_,button)
         tamerquestcheck()
	end,
	OnTooltipShow = function(tooltip)
		 DrawTCheckMainframe(tooltip,satchels_table,true)
	end,
})

local eventframe = CreateFrame("FRAME","DTCEventFrame")
eventframe:RegisterEvent("PLAYER_ENTERING_WORLD");
eventframe:RegisterEvent("ADDON_LOADED");
local function eventhandler(self, event, ...)
 if event == "PLAYER_ENTERING_WORLD" then
  OpenCalendar()
  --eventframe:UnregisterEvent("PLAYER_ENTERING_WORLD")
  --eventframe = nil
 elseif event == "ADDON_LOADED" then
  if not DailyTamerCheck_Options then
   DailyTamerCheck_Options = {}
   DailyTamerCheck_Options["show_coordinates"] = true
  end
  -- generate base dtc tables with coordinates at start
  GenerateDTCTables()
 end
end
eventframe:SetScript("OnEvent", eventhandler);

-- slash command
SLASH_DAILYTAMERCHECK1 = "/dtcheck"
SLASH_DAILYTAMERCHECK2 = "/dtc"
SlashCmdList["DAILYTAMERCHECK"] = tamerquestcheck